package uk.ac.shef;

import com.zerog.ia.api.pub.*;

import java.io.*;

public class ScriptEditor extends CustomCodeAction {

  public String getUninstallStatusMessage() {
    return "";
  }
  public String getInstallStatusMessage() {
    return "";
  }

  public void install(InstallerProxy proxy)
    throws com.zerog.ia.api.pub.InstallException {
    try{

      String gateHome = proxy.substitute("$USER_INSTALL_DIR$");
      int loc;
      while((loc = gateHome.indexOf("\"")) != -1){
        gateHome = gateHome.substring(0, loc) + gateHome.substring(loc +1);
      }
      //this points to the user selected VM
      String javaHome = proxy.substitute("$JAVA_HOME$");

      while((loc = javaHome.indexOf("\"")) != -1){
        javaHome = javaHome.substring(0, loc) + javaHome.substring(loc +1);
      }
      String fileSep = System.getProperty("file.separator");
      File gateBat = new File(gateHome + fileSep + "bin" + fileSep + "gate.bat");
      if(gateBat.exists()){
        //DOS Style
        String nl = "\r\n";
        BufferedReader reader = new BufferedReader(new FileReader(gateBat));
        String text = "";
        //skip some lines
        for(int i = 0; i < Utils.SKIP_LINES_IN_GATE_BAT; i++){
          text += reader.readLine() + nl;
        }
        //add the extra lines
        text += nl +
                "REM ######################################################################" + nl +
                "REM The following lines are generated by the installer" + nl +
                "REM ######################################################################" + nl;
        text += "set GATE_HOME=" + gateHome + nl;
        text += "set JAVA_HOME=" + javaHome + nl;

        //find out if we're running JRE or JDK
        File toolsjar = new File(javaHome + fileSep + "lib" +
                                 fileSep + "tools.jar");
        if(toolsjar.exists()){
          //gate will be using a JDK; no tools.jar required
          text += "set TOOLSJAR=" + javaHome + fileSep + "lib" +
              fileSep + "tools.jar" + nl;
        }else{
          //gate will be using a JRE; let's find the right tools.jar for it
          text += "set TOOLSJAR=" + gateHome + fileSep + "bin" +
              fileSep + "tools14.jar" + nl;
        }

        text += nl +
                "REM ######################################################################" + nl +
                "REM Installer generated text ends here" + nl +
                "REM ######################################################################" + nl;

        //add the rest of the lines
        String line;
        while((line = reader.readLine()) != null) text += line + nl;

        //if on windows but not 98 or 95 add title for the start command
//        String os = System.getProperty("os.name") +
//                    System.getProperty("os.version");
//        os = os.toLowerCase();
//        if(os.indexOf("windows") != -1 &&
//           os.indexOf("98") == -1 &&
//           os.indexOf("95") == -1 &&
//           os.indexOf("Me") == -1){
//          //we're on Windows but we're not on 95, 98, or Me
//          loc = text.lastIndexOf("start ") + 6;
//          text = text.substring(0, loc) + " \"Gate\" " +
//                 text.substring(loc);
//        }

        reader.close();
        if(gateBat.canWrite()){
          if(gateBat.delete()){
            FileWriter writer = new FileWriter(gateBat);
            writer.write(text);
            writer.flush();
            writer.close();
          }else{
            Utils.showErr("Could not delete gate.bat at" +
                                       gateBat.toString());
            throw new NonfatalInstallException("Could not delete gate.bat at" +
                                       gateBat.toString());
          }
        }else{
          Utils.showErr("Could not write into gate.bat at" +
                                     gateBat.toString());
          throw new NonfatalInstallException("Could not write into gate.bat at" +
                                     gateBat.toString());
        }

      }else{
        Utils.showErr("Could not locate gate.bat at" +
                                   gateBat.toString());
        throw new NonfatalInstallException("Could not locate gate.bat at" +
                                   gateBat.toString());
      }


      File gateSh = new File(gateHome + fileSep + "bin" + fileSep + "gate.sh");
      if(gateSh.exists()){
        //UNIX style
        String nl = "\n";
        BufferedReader reader = new BufferedReader(new FileReader(gateSh));
        String text = "";
        //skip some lines
        for(int i = 0; i < Utils.SKIP_LINES_IN_GATE_SH; i++){
          text += reader.readLine() + nl;
        }
        //add the extra lines
        text += nl +
                "####################################################" + nl +
                "# the following lines are generated by the installer" + nl +
                "####################################################" + nl;

        text += "GATE_HOME=" + gateHome + nl;
        text += "JAVA_HOME=" + javaHome + nl;

        //find out if we're running JRE or JDK
        File toolsjar = new File(javaHome + fileSep + "lib" +
                                 fileSep + "tools.jar");
        if(toolsjar.exists()){
          //gate will be using a JDK; no tools.jar required
          text += "TOOLSJAR=" + javaHome + fileSep + "lib" +
              fileSep + "tools.jar" + nl;
        }else{
          //gate will be using a JRE; let's find the right tools.jar for it
          text += "TOOLSJAR=" + gateHome + fileSep + "bin" +
              fileSep + "tools14.jar" + nl;
        }

        text += nl +
                "####################################################" + nl +
                "# Installer generated text ends here " + nl +
                "####################################################" + nl;

        //add the rest of the lines
        String line;
        while((line = reader.readLine()) != null) text += line + nl;

        reader.close();
        if(gateSh.canWrite()){
          if(gateSh.delete()){
            FileWriter writer = new FileWriter(gateSh);
            writer.write(text);
            writer.flush();
            writer.close();

          }else{
            Utils.showErr("Could not delete gate.sh at" +
                                       gateSh.toString());
            throw new NonfatalInstallException("Could not delete gate.sh at" +
                                       gateSh.toString());
          }
        }else{
          Utils.showErr("Could not write into gate.sh at" +
                                     gateSh.toString());
          throw new NonfatalInstallException("Could not write into gate.sh at" +
                                     gateSh.toString());
        }


      }else{
        Utils.showErr("Could not locate gate.sh at" +
                                   gateSh.toString());
        throw new NonfatalInstallException("Could not locate gate.sh at" +
                                   gateSh.toString());
      }


    }catch(IOException ioe){
      Utils.showErr(ioe.toString());
      throw new NonfatalInstallException(ioe.toString());
    }
  }

  public void uninstall(UninstallerProxy parm1) throws com.zerog.ia.api.pub.InstallException {
  }

}